#include <imsls.h>
#include <stdio.h>
extern FILE* imsls_fopen(char* filename, char* mode);
extern void imsls_fclose(FILE* file);
int main(){
   FILE *file;
   char *filename = "NeuralNetworkEx2.txt";
   float *trainStats;
   int i, j;
   int n_patterns       =13;
   int n_inputs4        =4; 
   int n_inputs3        =3; 
   int n_cont4          =4; 
   int n_cont3          =3;
   int n_outputs        =1;
   int *categoricalAtt=NULL;
   float ss3, ss4;
   float cont4[4*13], cont3[3*13], y[13];
   float *draperSmithData;
   float forecasts3[13], forecasts4[13];
   Imsls_f_NN_Network *networkStructure;
   draperSmithData = imsls_f_data_sets(5,0);

   for(i=0; i < n_patterns; i++){
      y[i] = draperSmithData[5*i+4];
      for(j=0; j<4; j++){
         cont4[i*4+j] = draperSmithData[5*i+j];
         if(j<3) cont3[i*3+j] = draperSmithData[5*i+j];
      }
   }
   networkStructure = imsls_f_mlff_network_init(n_inputs4, 
                                                n_outputs);
   imsls_f_mlff_network(networkStructure, 
                        IMSLS_CREATE_HIDDEN_LAYER, 4, 
                        IMSLS_LINK_ALL, 0);
   imsls_random_seed_set(5555);
   trainStats = imsls_f_mlff_network_trainer(networkStructure, 
      n_patterns, 0, n_cont4,
      categoricalAtt, cont4, y, 
      IMSLS_MAX_STEP, 100.0,
      IMSLS_STAGE_I, 50, n_patterns,
      IMSLS_FORECASTS_USER, &forecasts4, 0);
   /* open filestream */
   file = imsls_fopen(filename, "w");
   /* Write the number of network being placed into this file */
   fprintf(file, "%d\n", 2);
   printf("Writing network for model with 4 continuous attributes\n");
   imsls_f_mlff_network_write(networkStructure, NULL, 
                               IMSLS_PRINT, IMSLS_FILE, file, 0);

   /* Create second neural network */
   imsls_f_mlff_network_free(networkStructure);
   imsls_free(trainStats);
   networkStructure = imsls_f_mlff_network_init(n_inputs3, 
                                                n_outputs);
   imsls_f_mlff_network(networkStructure, 
                         IMSLS_CREATE_HIDDEN_LAYER, 4, 
                         IMSLS_LINK_ALL, 0);
   imsls_random_seed_set(5555);
   trainStats = imsls_f_mlff_network_trainer(networkStructure, 
      n_patterns, 0, n_cont3,
      categoricalAtt, cont3, y,
      IMSLS_MAX_STEP, 100.0,
      IMSLS_STAGE_I, 50, n_patterns, 
      IMSLS_FORECASTS_USER, &forecasts3, 0);
   printf("Writing network for model with 3 continuous attributes\n");
   imsls_f_mlff_network_write(networkStructure, NULL, IMSLS_PRINT, 
                                                 IMSLS_FILE, file, 0);
   imsls_fclose(file);
   printf("File %s Closed.\n", filename);
   printf("\nPrinting Forecasts for models with 3 and 4");
   printf(" continuous attributes:\n");
   printf("\n                                           ");
   printf("FORECAST  FORECAST\n");
   printf("OBS    X1      X2      X3      X4      Y   ");
   printf("n_cont=3  n_cont=4\n");
   ss4 = 0;
   ss3 = 0;
   for(i=0; i<n_patterns; i++) {
      ss4 += (y[i]-forecasts4[i])*(y[i]-forecasts4[i]);
      ss3 += (y[i]-forecasts3[i])*(y[i]-forecasts3[i]);
      printf("%2d %7.2f %7.2f %7.2f %7.2f %7.2f %7.2f %9.2f\n", 
      i, cont4[i*4], cont4[i*4+1], cont4[i*4+2],
      cont4[i*4+3], y[i], forecasts3[i], forecasts4[i]);
   }
   printf("Sum of Squared Residuals for X1-X3: %7.2f\n", ss3);
   printf("Sum of Squared Residuals for X1-X4: %7.2f\n", ss4);
}
